> ## Documentation Index
> Fetch the complete documentation index at: https://docs.julep.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Or Update User



## OpenAPI

````yaml https://api.julep.ai/api/openapi.json post /users/{user_id}
openapi: 3.1.0
info:
  title: Julep Agents API
  description: API for Julep Agents
  termsOfService: https://www.julep.ai/terms
  contact:
    name: Julep
    url: https://www.julep.ai/
    email: developers@julep.ai
  version: 0.4.0
servers:
  - url: /api
security: []
paths:
  /users/{user_id}:
    post:
      tags:
        - users
      summary: Create Or Update User
      operationId: create_or_update_user_users__user_id__post
      parameters:
        - name: user_id
          in: path
          required: true
          schema:
            type: string
            format: uuid
            title: User Id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateOrUpdateUserRequest'
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/User'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyHeader: []
components:
  schemas:
    CreateOrUpdateUserRequest:
      properties:
        metadata:
          anyOf:
            - type: object
            - type: 'null'
          title: Metadata
        name:
          type: string
          maxLength: 120
          pattern: >-
            ^[\p{L}\p{Nl}\p{Pattern_Syntax}\p{Pattern_White_Space}]+[\p{ID_Start}\p{Mn}\p{Mc}\p{Nd}\p{Pc}\p{Pattern_Syntax}\p{Pattern_White_Space}]*$
          title: Name
          default: ''
        about:
          type: string
          title: About
          default: ''
        project:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
              pattern: ^[a-zA-Z][a-zA-Z0-9_]*$
            - type: 'null'
          title: Project
      type: object
      title: CreateOrUpdateUserRequest
    User:
      properties:
        id:
          type: string
          format: uuid
          title: Id
          readOnly: true
        metadata:
          anyOf:
            - type: object
            - type: 'null'
          title: Metadata
        created_at:
          type: string
          format: date-time
          title: Created At
          readOnly: true
        updated_at:
          type: string
          format: date-time
          title: Updated At
          readOnly: true
        name:
          type: string
          maxLength: 120
          pattern: >-
            ^[\p{L}\p{Nl}\p{Pattern_Syntax}\p{Pattern_White_Space}]+[\p{ID_Start}\p{Mn}\p{Mc}\p{Nd}\p{Pc}\p{Pattern_Syntax}\p{Pattern_White_Space}]*$
          title: Name
          default: ''
        about:
          type: string
          title: About
          default: ''
        project:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
              pattern: ^[a-zA-Z][a-zA-Z0-9_]*$
            - type: 'null'
          title: Project
      type: object
      required:
        - id
        - created_at
        - updated_at
      title: User
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization

````